"""
Copyright 2012 Austin Noto-Moniz

This file is part of PyStick.

PyStick is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PyStick is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PyStick.  If not, see <http://www.gnu.org/licenses/>.
"""

import ast
from ast import AST, iter_fields, dump as dumpAST

class Call(ast.Call):
	def __init__(self, **kwargs):
		if "args" not in kwargs:
			kwargs["args"] = []
		if "keywords" not in kwargs:
			kwargs["keywords"] = []
		if "starargs" not in kwargs:
			kwargs["starargs"] = None
		if "kwargs" not in kwargs:
			kwargs["kwargs"] = None
		super(Call,self).__init__(**kwargs)

class Print(ast.Print):
	def __init__(self, **kwargs):
		if "dest" not in kwargs:
			kwargs["dest"] = None
		if "nl" not in kwargs:
			kwargs["nl"] = True
		super(Print,self).__init__(**kwargs)

class Dict(ast.Dict):
	def __init__(self, **kwargs):
		if "keys" not in kwargs:
			kwargs["keys"] = []
		if "values" not in kwargs:
			kwargs["values"] = []
		super(Dict,self).__init__(**kwargs)

class Slice(ast.Slice):
	def __init__(self, **kwargs):
		if "lower" not in kwargs:
			kwargs["lower"] = None
		if "upper" not in kwargs:
			kwargs["upper"] = None
		if "step" not in kwargs:
			kwargs["step"] = None
		super(Slice,self).__init__(**kwargs)

class comprehension(ast.comprehension):
	def __init__(self, **kwargs):
		if "ifs" not in kwargs:
			kwargs["ifs"] = []
		super(comprehension,self).__init__(**kwargs)
