"""
Copyright 2012 Austin Noto-Moniz

This file is part of PyStick.

PyStick is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PyStick is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PyStick.  If not, see <http://www.gnu.org/licenses/>.
"""

from logging import log
from invariants import detect

def select_inputs(input_groups):
	selected = set()
	for inputs in input_groups:
		selected.update(input_groups[inputs])
	return list(selected)

def run(program_text, func, input_groups):
	input_list = select_inputs(input_groups)
	traces = log(program_text,func,input_list)
	return detect(traces)
