"""
Copyright 2012 Austin Noto-Moniz

This file is part of PyStick.

PyStick is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PyStick is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PyStick.  If not, see <http://www.gnu.org/licenses/>.
"""

class Range(object):
	def __init__(self, var, min_val, max_val):
		self.var = var
		self.min_val = min_val
		self.max_val = max_val
	
	def __str__(self):
		return "{0} <= {1} <= {2}".format(self.min_val,self.var,self.max_val)

class Undef(Range):
	def __init__(self, var):
		Range.__init__(self,var,None,None)

	def __str__(self):
		return "{0} is undefined at this point.".format(self.var)

class Const(Range):
	def __init__(self, var, val):
		Range.__init__(self,var,val,None)
	
	def __str__(self):
		return "{0} == {1}".format(self.var,self.min_val)


def run_funcs(func_list, args):
	results = {}
	for func in func_list:
		try:
			results[func] = func(*args)
		except KeyboardInterrupt:
			raise
		except:
			pass
	return results
