"""
Copyright 2012 Austin Noto-Moniz

This file is part of PyStick.

PyStick is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PyStick is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PyStick.  If not, see <http://www.gnu.org/licenses/>.
"""

from constraint import *

MAX_VAL = 10

def _constraint_from_strings(vars, constraint):
	var_str = str(vars)[1:-1].replace('\'','')
	func_str = "lambda {0}: {1}".format(var_str,str(constraint))
	return eval(func_str)

def get_solutions(path_constraints, scope_vars):
	problem = Problem()
	problem.addVariables(scope_vars,range(-MAX_VAL,MAX_VAL+1))

	for constraint in path_constraints:
		constraint_func = _constraint_from_strings(scope_vars,constraint)
		problem.addConstraint(constraint_func,scope_vars)
	
	return problem.getSolutions()
