"""
Copyright 2012 Austin Noto-Moniz

This file is part of PyStick.

PyStick is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PyStick is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PyStick.  If not, see <http://www.gnu.org/licenses/>.
"""

from imp import load_source as load_module
from os.path import basename,splitext

from dart import run as run_DART
from daikon import run as run_Daikon
from report import print_results

def run(file_name, func_name):
	program_text = open(file_name,'r').read()
	user_mod = load_module(splitext(basename(file_name))[0],file_name)
	user_func = getattr(user_mod,func_name)

	input_dict = run_DART(program_text,user_func)
	results = run_Daikon(program_text,user_func,input_dict)

	print_results(results)
