from os import chdir,mkdir
from os.path import dirname
from shutil import rmtree
from subprocess import Popen
from time import clock
import informal_tests

runs = 5
total_time = {}
output_dir = "informal_test_output"
chdir(".\\{0}".format(dirname(__file__)))

output_file = "{0}\\{1}_out.txt".format(output_dir,"{0}")
error_file = "{0}\\{1}_err.txt".format(output_dir,"{0}")
command_str = "python ..\pystick\main.py informal_tests.py {0}"

test_names = []
for test_name in dir(informal_tests):
	if not test_name.startswith("__"):
		test_names.append(test_name)
		total_time[test_name] = 0

try:
	rmtree(output_dir)
except WindowsError as mess:
	if int(mess[0])==3:
		pass
	else:
		raise

mkdir(output_dir)
for run in range(0,runs):
	print "RUN {0}".format(run+1)
	for test_name in test_names:
		print test_name
		out = open(output_file.format(test_name),'a')
		err = open(error_file.format(test_name),'a')
		command = command_str.format(test_name)

		start = clock()
		proc = Popen(command,stdout=out,stderr=err)
		proc.wait()
		duration = clock()-start

		total_time[test_name] += duration
		print "{0} seconds".format(duration)
		print
	print

total = 0
print "AVERAGE TIMES"
for test_name in total_time:
	avg = total_time[test_name]/runs
	total += avg
	print "{0}: {1} seconds".format(test_name,avg)

print "OVERALL AVERAGE: {0} seconds".format(total/len(total_time))
